<template>
  <v-app>
    <!-- spinner -->
    <div class="text-center">
      <v-dialog v-model="dialog_loader" hide-overlay persistent width="300">
        <v-card color="#428bca" dark>
          <v-card-text class="text-center" style="color: white">
            Wait . . .
            <v-progress-linear
              indeterminate
              color="white"
              class="mb-0"
            ></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>
    <div>
      <v-container>
        <v-card>
          <v-card-title class="pb-0">
            <v-col cols="12" sm="8" md="8"><h1>Dashboard</h1></v-col>
            <v-col cols="12" sm="4" md="4"> </v-col>
          </v-card-title>

          <v-row class="pt-0 mt-0">
            <v-col cols="12" sm="8" md="8" lg="8">
              <v-container class="py-2">
                <span style="font-size: 28px" class="ml-4">
                  ภาพรวมรายเดือน
                  <v-icon style="font-size: 30px">mdi-chevron-right</v-icon>
                  <!-- <v-chip
                    filter
                    label
                    pill
                    v-on="on"
                    color="primary"
                    outlined
                    text-color="primary"
                  >
                    <span style="font-size: 17.5px; font-weight: 500">
                      {{ select_date }}
                      <v-icon>mdi-calendar-range</v-icon>
                    </span>
                  </v-chip> -->
                  {{ select_date }}
                </span>
                <v-divider class="ml-4" style="width: 70%"></v-divider>
              </v-container>
            </v-col>

            <v-col cols="12" sm="4" md="4" lg="4">
              <v-container class="py-0">
                <v-dialog
                  ref="dialog"
                  v-model="modal"
                  :return-value.sync="date"
                  persistent
                  width="290px"
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                      v-model="select_date"
                      label="Select year Select month"
                      append-icon="mdi-calendar"
                      readonly
                      v-bind="attrs"
                      v-on="on"
                      outlined
                      dense
                    ></v-text-field>
                  </template>

                  <v-date-picker v-model="select_date" scrollable type="month">
                    <v-spacer></v-spacer>
                    <v-btn text color="primary" @click="modal = false">
                      Cancel
                    </v-btn>
                    <v-btn text color="primary" @click="filter_date()">
                      OK
                    </v-btn>
                  </v-date-picker>
                </v-dialog>
              </v-container>
            </v-col>

            <v-col cols="12" sm="6" md="6" lg="3">
              <v-card class="ma-3" outlined>
                <v-list-item>
                  <v-list-item-avatar
                    tile
                    class="mt-n7"
                    height="80"
                    width="80"
                    elevation="10"
                  >
                    <v-sheet
                      style="
                        background: linear-gradient(60deg, #66bb6a, #43a047);
                      "
                      height="80"
                      elevation="10"
                      class="px-10"
                    >
                      <v-icon dark large>mdi-film</v-icon>
                    </v-sheet>
                  </v-list-item-avatar>
                  <v-list-item-content>
                    <div class="overline text-right">Balance Film</div>
                    <v-list-item-title class="headline mb-1 text-right">
                      {{ balance_film }} / {{ limit_film }}
                    </v-list-item-title>
                    <div><v-divider></v-divider></div>
                  </v-list-item-content>
                </v-list-item>
                <v-card-actions>
                  <v-icon text class="ma-2">mdi-person</v-icon>
                  <span style="font-size: 13.5px">
                    * จำนวนฟิล์มที่เหลือ {{ balance_film }} จาก
                    {{ limit_film }}</span
                  >
                </v-card-actions>
              </v-card>
            </v-col>

            <v-col cols="12" sm="6" md="6" lg="3">
              <v-card class="ma-3" outlined>
                <v-list-item>
                  <v-list-item-avatar
                    tile
                    class="mt-n7"
                    height="80"
                    width="80"
                    elevation="10"
                  >
                    <v-sheet
                      style="
                        background: linear-gradient(60deg, #26c6da, #00acc1);
                      "
                      width="80"
                      height="80"
                      elevation="10"
                    >
                      <v-icon dark large>mdi-cloud-check</v-icon>
                    </v-sheet>
                  </v-list-item-avatar>
                  <v-list-item-content>
                    <div class="overline text-right">Used Film</div>
                    <v-list-item-title class="headline mb-1 text-right">
                      {{ use_film }}
                    </v-list-item-title>
                    <div><v-divider></v-divider></div>
                  </v-list-item-content>
                </v-list-item>
                <v-card-actions>
                  <v-icon text class="ma-2">mdi-subscriptions</v-icon>
                  <span style="font-size: 13.5px">
                    * จำนวนฟิล์มที่ใช้ไปทั้งหมด {{ use_film }}</span
                  >
                </v-card-actions>
              </v-card>
            </v-col>

            <v-col cols="12" sm="6" md="6" lg="3">
              <v-card class="ma-3" outlined>
                <v-list-item>
                  <v-list-item-avatar
                    tile
                    class="mt-n7"
                    height="80"
                    width="80"
                    elevation="10"
                  >
                    <v-sheet
                      style="
                        background: linear-gradient(60deg, #ffa726, #fb8c00);
                      "
                      width="80"
                      height="80"
                      elevation="10"
                    >
                      <v-icon dark large>mdi-finance</v-icon>
                    </v-sheet>
                  </v-list-item-avatar>
                  <v-list-item-content>
                    <div class="overline text-right">Over Film</div>
                    <v-list-item-title class="headline mb-1 text-right">
                      {{ over_film }}
                    </v-list-item-title>
                    <div><v-divider></v-divider></div>
                  </v-list-item-content>
                </v-list-item>
                <v-card-actions>
                  <v-icon text class="ma-2"></v-icon>
                  <span style="font-size: 13.5px">
                    * จำนวนฟิล์มที่ใช้เกินทั้งหมด {{ over_film_default }}</span
                  >
                </v-card-actions>
              </v-card>
            </v-col>

            <v-col cols="12" sm="6" md="6" lg="3">
              <v-card class="ma-3" outlined>
                <v-list-item>
                  <v-list-item-avatar
                    tile
                    class="mt-n7"
                    height="80"
                    width="80"
                    elevation="10"
                  >
                    <v-sheet color="red" width="80" height="80" elevation="10">
                      <v-icon dark large>mdi-alert-circle-outline</v-icon>
                    </v-sheet>
                  </v-list-item-avatar>
                  <v-list-item-content>
                    <div class="overline text-right">Fail Film</div>
                    <v-list-item-title class="headline mb-1 text-right">
                      {{ fail_film }}
                    </v-list-item-title>
                    <div><v-divider></v-divider></div>
                  </v-list-item-content>
                </v-list-item>
                <v-card-actions>
                  <!-- <v-icon text class="ma-2" color="red">mdi-alert</v-icon> -->
                  <span style="font-size: 13.5px">
                    * จำนวนฟิล์มล้มเหลวทั้งหมด {{ fail_film }}</span
                  >
                </v-card-actions>
              </v-card>
            </v-col>

            <v-col cols="12" sm="8" md="8" lg="8">
              <v-container class="py-2">
                <span style="font-size: 28px" class="ml-4">
                  ตารางประวัติการอัพโหลด
                  <v-icon style="font-size: 30px">mdi-history</v-icon>
                </span>
                <v-divider class="ml-4" style="width: 70%"></v-divider>
              </v-container>
            </v-col>

            <v-col cols="12" sm="4" md="4" lg="4">
              <v-container class="py-0">
                <v-text-field
                  v-model="search"
                  append-icon="mdi-magnify"
                  label="Search username / status"
                ></v-text-field>
              </v-container>
            </v-col>
          </v-row>

          <div>
            <v-data-table
              :headers="headers"
              :items="all_dashboard"
              :search="search"
              :items-per-page="5"
              class="elevation-1 ma-3"
            >
              <template v-slot:item.status_wait="{ item }">
                <span v-if="item.status_wait == 'success'" style="color: teal"
                  >Success</span
                >
                <span v-else style="color: red">Fail </span>
              </template>
            </v-data-table>
          </div>

          <v-card class="text-center ma-3" outlined>
            <v-card-title>
              <v-col cols="12" sm="8" md="8">
                <span v-if="all_year.length != 0">
                  ภาพรวมรายปี {{ select_year }}</span
                >
              </v-col>
              <v-col cols="12" sm="4" md="4">
                <v-select
                  type="year"
                  class="pa-0"
                  :items="items"
                  v-model="select_year"
                  label="select year for filter"
                  dense
                  outlined
                ></v-select>
              </v-col>
            </v-card-title>
            <div id="chart" v-if="all_year.length != 0">
              <apexchart
                type="bar"
                height="300"
                :options="chartOptions"
                :series="series"
              ></apexchart>
            </div>
            <div v-else class="mb-12">
              <p style="font-size: 20px">
                ไม่พบข้อมูลภาพรวมรายปี {{ select_year }}
              </p>
            </div>
          </v-card>
        </v-card>
      </v-container>
    </div>
  </v-app>
</template>

<script>
import moment from "moment";
export default {
  data() {
    return {
      // api: "https://1ls.manageai.co.th",
      api: "https://1ls-demo.manageai.co.th",
      // api: "http://localhost:8080",
      moment,
      search: "",
      dialog_loader: false,
      chip_selectdate: true,
      balance_film: 0,
      limit_film: 0,
      use_film: 0,
      fail_film: 0,
      over_film: 0,
      over_film_default: 0,
      items: [],
      select_date: new Date().toISOString().substr(0, 10),
      select_year: new Date().toISOString().substr(0, 10),
      date: new Date().toISOString().substr(0, 10),
      menu: false,
      modal: false,
      series: [
        {
          name: "Servings",
          data: [],
        },
      ],
      chartOptions: {
        annotations: {
          points: [
            {
              x: "Bananas",
              seriesIndex: 0,
              label: {
                borderColor: "#775DD0",
                offsetY: 0,
                style: {
                  color: "#fff",
                  background: "#775DD0",
                },
                text: "Bananas are good",
              },
            },
          ],
        },
        chart: {
          height: 300,
          type: "bar",
        },
        plotOptions: {
          bar: {
            columnWidth: "10%",
            endingShape: "rounded",
            dataLabels: {
              position: "top",
            },
          },
        },
        dataLabels: {
          formatter: function (val) {
            return val;
          },
          enabled: true,
          offsetY: -20,
          style: {
            fontSize: "12px",
            colors: ["#304758"],
          },
        },
        stroke: {
          width: 0,
        },

        grid: {
          row: {
            colors: ["#fff", "#f2f2f2"],
          },
        },
        xaxis: {
          labels: {
            rotate: -45,
          },
          categories: [],
          //   tickPlacement: "on",
        },
        yaxis: {
          title: {
            text: "U S E  F I L M",
          },
        },
        fill: {
          show: true,
          colors: ["#1DE9B6"],
        },
      },
      headers: [
        {
          text: "Username",
          align: "start",
          value: "username",
          sortable: false,
        },
        {
          text: "Filename",
          align: "start",
          value: "old_filename",
          sortable: false,
        },
        {
          text: "Action",
          align: "start",
          value: "action",
          sortable: false,
        },
        {
          text: "Timestamp",
          align: "start",
          value: "upload_datetime",
          sortable: false,
        },
        {
          text: "Status",
          align: "start",
          value: "status_wait",
          sortable: false,
        },
      ],
      all_dashboard: [],
      all_year: [],
      chart: [],
      data_number_year: [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12],
      count_number: 0,
      array_test: [],
    };
  },
  mounted() {
    console.log(this.data_number_year);
    this.count_number = 0;
    this.data = [];
    this.select_date = moment(this.select_date).format("YYYY-MM");
    this.select_year = moment(this.select_year).format("YYYY");
    console.log(this.select_year);
    let array_year = [];
    for (let index = this.select_year - 3; index <= this.select_year; index++) {
      console.log(index);
      array_year.push(String(index));
    }
    array_year.sort();
    array_year.sort(function (a, b) {
      return b - a;
    });
    this.items = array_year;
    this.select_year = moment(this.select_year).format("YYYY");
    console.log("****", array_year);
    this.get_month_dashboard();
    this.get_year_dashboard();
  },
  watch: {
    select_year(val) {
      console.log("watch", this.chartOptions.xaxis.categories);
      console.log("select_year", val);
      this.get_year_dashboard();
    },
  },
  methods: {
    get_month_dashboard() {
      this.dialog_loader = true;
      this.axios
        .get(
          process.env.VUE_APP_API + "/api/v3/film_overview/Month_filmoverview",
          {
            params: {
              hospital_id: this.$cookies.get("info_login").hospital_id,
              user_id: this.$cookies.get("info_login").user_id,
              date_time: this.select_date + "-01",
            },
            headers: {
              Authorization: this.$cookies.get("info_login").session_id,
            },
          }
        )
        .then((response) => {
          console.log("response", response);
          this.balance_film = response.data.data.balance_film;
          this.limit_film = response.data.data.limit_film;
          this.use_film = response.data.data.use_film;
          this.over_film = response.data.data.overfilm;
          this.over_film_default = response.data.data.overfilm;
          var file_fail = response.data.data.file_fail;
          var file_wait = response.data.data.file_wait;
          this.fail_film = file_fail + file_wait;
          this.all_dashboard = response.data.data.dashborad;
          // check
          for (
            let index = 0;
            index < response.data.data.dashborad.length;
            index++
          ) {
            if (response.data.data.dashborad[index].status_wait == "wait") {
              console.log(response.data.data.dashborad[index].status_wait);
              response.data.data.dashborad[index].status_wait = "Fail";
              this.all_dashboard[index].status_wait ==
                response.data.data.dashborad[index].status_wait;
            }
          }
          console.log("all", this.all_dashboard);
          if (this.fail_film > 0) {
            if (this.over_film == 0) {
              this.balance_film = this.balance_film + this.fail_film;
            }
            //
            else if (this.over_film > this.fail_film) {
              this.over_film = this.over_film - this.fail_film;
            }
            //
            else if (this.over_film < this.fail_film) {
              let count = 0;
              console.log("balance", this.balance_film);
              count = this.fail_film - this.over_film;
              this.balance_film = this.balance_film + count;
            }
          }
          //
          else if (this.overfilm == 0) {
            this.balance_film = this.balance_film + this.fail_film;
          }
          this.dialog_loader = false;
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            this.dialog_loader = false;
            // window.location.href = this.api;
          });
        });
    },

    get_year_dashboard() {
      this.dialog_loader = true;
      this.axios
        .get(
          process.env.VUE_APP_API + "/api/v3/film_overview/Year_filmoverview",
          {
            params: {
              hospital_id: this.$cookies.get("info_login").hospital_id,
              user_id: this.$cookies.get("info_login").user_id,
              date_time: this.select_year,
            },
            headers: {
              Authorization: this.$cookies.get("info_login").session_id,
            },
          }
        )
        .then((response) => {
          console.log("response-year", response);
          var count = 0;
          this.chart = [];
          this.array_test = [];
          this.count_number = 0;
          this.all_year = response.data.data.dashborad;

          for (let i = 0; i < response.data.data.dashborad.length; i++) {
            //  console.log(moment(this.all_year[i].upload_datetime).format("MM"))
            if (this.chart == 0) {
              this.chart.push(
                moment(this.all_year[i].upload_datetime).format("MMM")
              );
            } else {
              //  console.log("type",typeof(moment(this.all_year[i].upload_datetime).format("MM")))
              //  console.log("chart",this.chart[i])
              if (this.chart[i] == undefined) {
                if (
                  this.chart[count] !=
                  moment(this.all_year[i].upload_datetime).format("MMM")
                ) {
                  this.chart.push(
                    moment(this.all_year[i].upload_datetime).format("MMM")
                  );
                  count = count + 1;
                }
              } else {
                console.log("test");
              }
            }
          }
          for (
            let index = 0;
            index < response.data.data.dashborad.length;
            index++
          ) {
            console.log(
              moment(
                response.data.data.dashborad[index].upload_datetime
              ).format("M")
            );
            this.array_test.push(
              moment(
                response.data.data.dashborad[index].upload_datetime
              ).format("M")
            );
          }
          console.log("array_test", this.array_test);
          var counts = {};
          this.array_test.forEach(function (x) {
            counts[x] = (counts[x] || 0) + 1;
          });
          console.log("object-counts", counts);
          const myArr = Object.values(counts);
          console.log("data", myArr);
          this.series.data = myArr;
          var allMonths = [
            "Jan",
            "Feb",
            "Mar",
            "Apr",
            "May",
            "Jun",
            "Jul",
            "Aug",
            "Sep",
            "Oct",
            "Nov",
            "Dec",
          ];
          var chart_real = this.chart;
          chart_real.sort(function (a, b) {
            return allMonths.indexOf(a) - allMonths.indexOf(b);
          });
          console.log("chart_real", chart_real);
          // console.log("chart",this.chart)
          (this.series = [
            {
              name: "Servings",
              data: myArr,
            },
          ]),
            (this.chartOptions = {
              ...this.chartOptions,
              ...{
                xaxis: {
                  categories: chart_real,
                },
              },
            });
          this.dialog_loader = false;
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log("error", error);
          // this.$swal({
          //   icon: "error",
          //   title: "Error!",
          //   text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
          //   confirmButtonText: "OK",
          //   allowOutsideClick: false,
          // }).then(() => {
          //   this.dialog_loader = false;
          //   // window.location.href = this.api;
          // });
        });
    },

    filter_date() {
      this.modal = false;
      this.get_month_dashboard();
    },

    reset_datetime() {
      var time_now = new Date().toISOString().substr(0, 10);
      this.select_date = moment(time_now).format("YYYY-MM");
      console.log("reset", this.select_date);
      this.get_month_dashboard();
    },
  },
};
</script>

<style>
</style>